// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6C500K/24DSI6C500K_1.x.x.x_GSC_DN/samples/signals/perform.c $
// $Rev: 52726 $
// $Date: 2023-04-03 14:03:29 -0500 (Mon, 03 Apr 2023) $

// 24DSI6C500K: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	s32	fref;

	errs	+= dsi6c500k_initialize			(args->fd, -1, 1);
	errs	+= dsi6c500k_control_mode		(args->fd, -1, 1, DSI6C500K_CONTROL_MODE_INITIATOR, NULL);
	errs	+= dsi6c500k_xcvr_type			(args->fd, -1, 1, DSI6C500K_XCVR_TYPE_TTL, NULL);

	// The output clock signal.
	gsc_label("Clock Output");
	printf("\n");
	gsc_label_level_inc();
	errs	+= dsi6c500k_query				(args->fd, -1, 1, DSI6C500K_QUERY_FREF_DEFAULT, &fref);
	errs	+= dsi6c500k_nvco				(args->fd, -1, 1, 25, NULL);
	errs	+= dsi6c500k_nref				(args->fd, -1, 1, 40, NULL);
	errs	+= dsi6c500k_ndiv				(args->fd, -1, 1, 2, NULL);
	errs	+= dsi6c500k_osr				(args->fd, -1, 1, DSI6C500K_OSR_256, NULL);
	errs	+= dsi6c500k_ch_grp_0_src		(args->fd, -1, 1, DSI6C500K_CH_GRP_SRC_RATE_GEN, NULL);
	errs	+= dsi6c500k_ext_clk_src		(args->fd, -1, 1, DSI6C500K_EXT_CLK_SRC_GRP_0, NULL);
	gsc_label_level_dec();

	// The output sync signal.
	gsc_label("Sync Output");
	printf("\n");
	gsc_label_level_inc();
	errs	+= dsi6c500k_burst_size			(args->fd, -1, 1, 1, NULL);
	errs	+= dsi6c500k_burst_rate_div		(args->fd, -1, 1, 10000, NULL);
	errs	+= dsi6c500k_burst_timer		(args->fd, -1, 1, DSI6C500K_BURST_TIMER_ENABLE, NULL);
	errs	+= dsi6c500k_burst				(args->fd, -1, 1, DSI6C500K_BURST_ENABLE, NULL);
	gsc_label_level_dec();

	gsc_label("Waiting");
	printf("%d seconds ... ", args->seconds);
	fflush(stdout);
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	errs	+= dsi6c500k_initialize(args->fd, -1, 1);

	return(errs);
}



